#include <CooperativeTask.h>

// Grundsaetzliche Annahme (-: es "mag" Ausnahmen geben ;-)
constexpr bool stromausfall {false};



class Piepser : public Task
{
  protected:
   int i; 
   bool &piepflag;
   
  public:
    Piepser(bool &piepflag):i(0),piepflag(piepflag){}

    virtual void run() override // 5 mal piepsen, wenn Flag gesetzt
    {
       
      TaskBlock
      {
        while(not stromausfall)
        {
          taskWaitFor(piepflag);
          for(i = 0; i < 5; i++) 
          {
             Serial.println(F("Piep"));
             //taskSwitch();
             taskPause(200);
          }
          piepflag = false; // fertig mit piepsen (Flag konsumieren)
        }
      }
    }
};

class Ampel: public Task // Ampelschaltung
{
  protected:
    unsigned long i = 0; // haelt die Ampelaufrufe
    bool &piepflag;
    const unsigned long takt;
   
  public:
    Ampel(bool &piepflag,const unsigned long takt):piepflag(piepflag),takt(takt){}
    
    virtual void run() override
    {
      i++; // run() Aufrufe zaehlen
  
      TaskBlock
      { 
        while(not stromausfall)
        {
          // rotPhase
          Serial.print(i);
          Serial.println(F(" Rot an - Gelb aus - Gruen aus"));
          taskPause(takt);
          
          
          // gelbPhase Type: Mit Rot
          Serial.print(i);
          Serial.println(F(" Rot an - Gelb an - Gruen aus"));
          taskPause(takt);
        
          
          // grünPhase
          Serial.print(i);
          Serial.println(F(" Rot aus - Gelb aus - Gruen an"));
          piepflag = true; //  piepsen aktivieren
          taskPause(takt);
         
          
          // gelbPhase Type: ohne Rot
          Serial.print(i);
          Serial.println(F(" Rot aus - Gelb an - Gruen aus"));
          taskPause(takt);
        }
     }
   } 
};

//--------------


const unsigned long leuchtDauer {2000}; // Ampeltakt
bool piepflag {false};                  // Merker, Piep Anforderung



Ampel      ampel(piepflag,leuchtDauer);
Piepser    piepser(piepflag);
Scheduler &scheduler = Scheduler::instance();

void setup() 
{
  Serial.begin(9600);
  scheduler.init();
}

void loop() 
{
  scheduler.run();  
}
