#include <CooperativeTask.h>

class BlinkTask: public Task
{
  protected:
    const byte pin;
    const unsigned long interval;
  
  public:
    BlinkTask(const byte pin,const unsigned long interval):
       pin(pin),
       interval(interval){}
    
    virtual void init() override
    {
      pinMode(pin,OUTPUT);
    }
    
    virtual void run() override
    {
      TaskBlock
      {
        digitalWrite(pin,HIGH);
        taskPause(interval);
        digitalWrite(pin,LOW);
        taskPause(interval);
      }
    }
};

class MasterTask: public Task
{
  protected:
    unsigned long interval;
    BlinkTask* blinker;
  
  public:
    MasterTask(const unsigned long interval):interval(interval),blinker(nullptr){}
    
    virtual void run() override
    {
      TaskBlock
      {
        blinker = new BlinkTask(13,500);
        (*blinker).init();
        taskPause(interval);
        delete blinker;
        blinker = nullptr;
        taskPause(interval);
      }
    }
    virtual ~MasterTask() override
    {
      delete blinker;
    }
};

MasterTask master(10000);
   
void setup() 
{
  Scheduler::instance().init();
}

void loop() 
{
  Scheduler::instance().run();
}
