#pragma once

/**
 *
 * Erste Vorstellung:
 * https://forum.arduino.cc/index.php?topic=578831.msg3955998#msg3955998
 * 
 * Implementiert:
 * https://de.wikipedia.org/wiki/Singleton_(Entwurfsmuster)
 * 
 */

template<typename ClientClass>
class Singleton
{
     
  private:
    static ClientClass *client;
    
  protected:
    Singleton(){}
    Singleton(const Singleton<ClientClass>&)              =delete;
    Singleton(Singleton<ClientClass>&&)                   =delete;
    Singleton & operator=(const Singleton<ClientClass>&)  =delete;
    Singleton & operator=(Singleton<ClientClass>&&)       =delete;

  public:
    static  ClientClass &instance()
    {
      if (!client) client = new ClientClass;
      return *client;
    }
     
    virtual ~Singleton()
    {
       delete client;
       client = nullptr;
    }
  };
 
template<typename ClientClass> inline ClientClass* Singleton<ClientClass>::client = nullptr;
